<?php
if (!defined('_PS_VERSION_'))
	exit;

class StatsOos extends Module
{
	private $_html = '';
	private $_query = '';
	private $_query2 = '';
	private $_option = '';

	public function __construct()
	{
		$this->name = 'statsoos';
		$this->tab = 'analytics_stats';
		$this->version = '1.6';
		$this->author = 'PrestaShop';
		$this->need_instance = 0;

		parent::__construct();

		$this->displayName = $this->l('Customer out of stock');
		$this->description = $this->l('Shows customers who are waiting for out of stock products.');
		$this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
	}
  public function install()
  {
    return (parent::install() AND $this->registerHook('AdminStatsModules'));
  }
  private function getOosPages($resultperpage, $page, $limit, $filtprod=false) 
  {
	$colnames='SHOW columns FROM `'._DB_PREFIX_.'mailalert_customer_oos` WHERE `Field`="date_add"';
	Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($colnames);
	$existda = Db::getInstance(_PS_USE_SQL_SLAVE_)->NumRows();
	$order="`date_add`,";
	if (!$existda) {
		$sqlalt='ALTER TABLE `'._DB_PREFIX_.'mailalert_customer_oos` ADD COLUMN `date_add` DATETIME NOT NULL';
		if (Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sqlalt))
			$order="";
	}
	
	$Whercond=$filtprod?"WHERE `id_product`=".$filtprod:"";
    $sql='SELECT `id_customer`, `customer_email`, `id_product`, `id_product_attribute`, `date_add`
      FROM `'._DB_PREFIX_.'mailalert_customer_oos`
	  '.$Whercond.'
      '.($limit == 1 ? '
      ORDER BY '.$order.'`id_product` DESC
      LIMIT '.(($page*$resultperpage)-$resultperpage).', '.$resultperpage 
      : '').'';
    return Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
  }
  private function getoosTop5($TopQty) 
  {
	$sql='SELECT `id_product`, `id_product_attribute`, COUNT(id_product) AS Quantity
			FROM `'._DB_PREFIX_.'mailalert_customer_oos` 
			GROUP BY id_product, id_product_attribute
			ORDER BY COUNT(id_product) DESC
			LIMIT '.$TopQty;
 
    return Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
  }
  
  private function deleteOos($f)
  {
    return Db::getInstance(_PS_USE_SQL_SLAVE_)->Execute('
      DELETE FROM `'._DB_PREFIX_.'mailalert_customer_oos` WHERE
      `id_customer` = "'.$f[0].'" AND
      `customer_email` = "'.$f[1].'" AND
      `id_product` = "'.$f[2].'" AND
      `id_product_attribute` = "'.$f[3].'"');
  }
  public function hookAdminStatsModules($params)
  {
    global $cookie;
    $page = !empty($_POST['page']) ? $_POST['page'] : '1';
    if (!empty($_POST['firstpage_x']))
      $page = 1;
    elseif (!empty($_POST['pagedown_x']))
      $page = $page - 1;
    elseif (!empty($_POST['pageup_x']))
      $page = $page + 1;
    elseif (!empty($_POST['lastpage_x']))
      $page = $_POST['nblastpage'];
    else
      $page = $page;
    $resultperpage = 20;
    if (Tools::isSubmit('submitDelOos')) {
      $oosBox = Tools::getValue('oosBox');
      foreach ($oosBox as $oos)
	$this->deleteOos(explode('|', $oos));
    }
	$filtprod=Tools::getValue('id_prod');

    //if ($this->v14)
      //$this->_html = '
     // <form name="submitStatsOos" method="post" action="index.php?tab=AdminStats&token='.Tools::getValue('token').'&module='.$this->name.'">';
    //else
      $this->_html = '
	  <div class="panel-heading">
			'.$this->displayName.'
	  </div>
      <form name="submitStatsOos" method="post" action="index.php?tab=AdminStats&token='.Tools::getValue('token').'&module='.$this->name.'">';
    $this->getOosPages($resultperpage, $page, 0);
    $totalOosPages = Db::getInstance(_PS_USE_SQL_SLAVE_)->NumRows();
    $totalpage = ceil($totalOosPages/$resultperpage);
    if ($totalpage == 0)
      $totalpage = 1;
    $oosPages = (array)$this->getOosPages($resultperpage, $page, 1, $filtprod);
    $this->_html .= '
      <fieldset class="widthfull space"><legend><img src="../modules/'.$this->name.'/img/setting.gif" /> '.$this->l('Pagination').'</legend>
      <p>
      '.$this->l('Go directly to page').' 
      <select onChange="submit();" name="page">
      ';
    for ($i = 1 ; $i <= $totalpage ; $i++)
    {
      $this->_html .='<option '.($i == $page ? 'selected="selected "': '').'value="'.$i.'">&nbsp;'.$i.'&nbsp;</option>';
    } 
    $this->_html .= '
      </select> / '.$totalpage.'
      </p>
      <p style="text-align: center; display: block; width:600px; border-top: 7px;">
      <input '.($page <= 1 ? 'style="display: none" ' : '').'name="firstpage" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-prev2.gif"/>
      &nbsp;<input '.($page <= 1 ? 'style="display: none" ' : '').'name="pagedown" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-prev.gif"/>
      &nbsp;'.$this->l('Page').' '.$page.' / '.$totalpage.'
      &nbsp;<input '.($page >= $totalpage ? 'style="display: none" ' : '').'name="pageup" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-next.gif"/>
      &nbsp;<input '.($page >= $totalpage ? 'style="display: none" ' : '').'name="lastpage" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-next2.gif"/>
      <input type="hidden" name="nblastpage" value="'.$totalpage.'">
      </p>
      </fieldset>';
	$topQt=5;//Quantity of top products
	$oosTopQty = (array)$this->getoosTop5($topQt);

    $this->_html .= '<fieldset class="widthfull space"><legend><img src="../modules/'.$this->name.'/img/more.gif" /> '.$this->l('Top ').$topQt.'</legend>';
	
	$this->_html .= '
      <table cellpadding="0" cellspacing="0" class="table space">
      <thead>
	  <tr>
      <th style="text-align: center;">'.$this->l('Product').'</th><th style="text-align: center;">'.$this->l('Attribute').'</th><th style="text-align: center;">'.$this->l('Qty').'</th></tr></thead>';
	 foreach ($oosTopQty as $oosTop)
    {
      $productTop = new Product($oosTop['id_product']);
      $attrNameTop = $oosTop['id_product_attribute'];
      $quantityTop = $oosTop['Quantity'];
      if ($attrNameTop == 0)
	$attrNameTop = '-';
     
      $urlTop = _PS_BASE_URL_.__PS_BASE_URI__.'product.php?id_product='.intval($productTop->id);
      if (!$productTop->active)
	$productColorTop = 'style="color:grey;"';
      elseif ($quantityTop > 0)
	$productColorTop = 'style="color:green;"';
      else
	$productColorTop = '';
      $this->_html .= '
	<thead>
	<tr>
	<td style="text-align: left;"><a href="index.php?tab=AdminStats&token='.Tools::getValue('token').'&module='.$this->name.'&id_prod='.intval($productTop->id).'"'.$productColorTop.'>#'.$oosTop['id_product'].' '.$productTop->name[intval($cookie->id_lang)].'</a></td>
	<td style="text-align: center;">'.$attrNameTop.'</td>
	<td style="text-align: center;">'.$quantityTop.'</td>
	</tr></thead>';
    }
    $this->_html .= '</table>';
	if (isset($filtprod) && $filtprod) {
		$this->_html .= '<a href="index.php?tab=AdminStats&token='.Tools::getValue('token').'&module='.$this->name.'"'.$productColorTop.'>Clear Filter</a>';
	}
	$this->_html .= '</fieldset>';
	
	 $this->_html .= '<fieldset class="widthfull space"><legend><img src="../modules/'.$this->name.'/img/logo.gif" /> '.$this->l('Visitor(s)').'</legend>';
    $this->_html .= $this->l('Total:').' '.intval($totalOosPages).'
      <table cellpadding="0" cellspacing="0" class="table space">
      <thead>
	  <tr>
      <th><input type="checkbox" name="checkme" onclick="checkDelBoxes(this.form, \'oosBox[]\', this.checked)" /></th>
      <th style="text-align: center;">'.$this->l('Date').'</th><th style="text-align: center;">'.$this->l('Customer').'</th><th style="text-align: center;">'.$this->l('E-mail').'</th><th style="text-align: center;">'.$this->l('Product').'</th><th style="text-align: center;">'.$this->l('Attribute').'</th></tr><thead>';
    foreach ($oosPages as $oosPage)
    {
      $customer = new Customer($oosPage['id_customer']);
      $product = new Product($oosPage['id_product']);
      $attrName = $oosPage['id_product_attribute'];
      $quantity = $product->quantity;
      if ($customer->id) {
	$customerName = $customer->firstname.' '.$customer->lastname;
	$customerEmail = $customer->email;
      }
      else {
	$customerName = '-';
	$customerEmail = $oosPage['customer_email'];
      }
      if ($attrName == 0)
	$attrName = '-';
      $attrs = $product->getAttributeCombinations(intval($cookie->id_lang));
      foreach ($attrs as $attr) {
	if ($attr['id_product_attribute'] == $oosPage['id_product_attribute']) {
	  $quantity = $attr['quantity'];
	  $attrName = $attr['group_name'].': '.$attr['attribute_name'];
	}
      }
      $url = _PS_BASE_URL_.__PS_BASE_URI__.'product.php?id_product='.intval($product->id);
      if (!$product->active)
	$productColor = 'style="color:grey;"';
      elseif ($quantity > 0)
	$productColor = 'style="color:green;"';
      else
	$productColor = '';
      if (Validate::isEmail($customerEmail))
	$emailColor = '';
      else
	$emailColor = 'color:red;';
	
	///////////// DATE FORMAT /////////////////
	
	//Format de la Date choisir US ou FR
	$date = $oosPage['date_add'];
	
	//FR 27-03-2008
	$timestamp = strtotime($date); //$timestamp = strtotime($date);
	$date_format = date('d-m-Y', $timestamp);// $date_format = date('d-m-Y', $timestamp);
		
	//US 
	//$date_format = $date ;
	
	/////////////////////////////////////////
      $this->_html .= '
	<tr>
	<td style="text-align: center;"><input type="checkbox" name="oosBox[]" value="'.implode('|', $oosPage).'" /></td>
	<td style="text-align: center;" nowrap="nowrap">'.$date_format.'</td>
	<td style="text-align: center;">'.$customerName.'</td>
	<td style="text-align: center; '.$emailColor.'">'.$customerEmail.'</td>
	<td style="text-align: left;"><a '.$productColor.'>#'.$oosPage['id_product'].' '.$product->name[intval($cookie->id_lang)].'</a></td>
	<td style="text-align: center;">'.$attrName.'</td>
	</tr>';
    }
    $this->_html .= '</table>';
    $this->_html .= '<br /><input type="submit" name="submitDelOos" class="button" value="'.$this->l('Delete selection').'">';
    $this->_html .= '</fieldset>';
    $this->_html .= '
      <fieldset class="widthfull space"><legend><img src="../modules/'.$this->name.'/img/setting.gif" /> '.$this->l('Pagination').'</legend>
      <p style="text-align: center; display: block; width:600px; border-top: 7px;">
      <input '.($page <= 1 ? 'style="display: none" ' : '').'name="firstpage" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-prev2.gif"/>
      &nbsp;<input '.($page <= 1 ? 'style="display: none" ' : '').'name="pagedown" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-prev.gif"/>
      &nbsp;'.$this->l('Page').' '.$page.' / '.$totalpage.'
      &nbsp;<input '.($page >= $totalpage ? 'style="display: none" ' : '').'name="pageup" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-next.gif"/>
      &nbsp;<input '.($page >= $totalpage ? 'style="display: none" ' : '').'name="lastpage" type="image" onclick="submit();" src="../modules/'.$this->name.'/img/list-next2.gif"/>
      <input type="hidden" name="nblastpage" value="'.$totalpage.'">
      </p>
      </fieldset>
      </form>';
    return $this->_html;
  }
}
?>
